;;;; object-uword-ref.scm
;;;; Kon Lovett, Mar '20

(cond-expand
  (64bit
    (define-constant C_WORD_SIZE (/ 64 8))
    (define-inline (pointer-uword-ref ptr) (pointer-u64-ref ptr)) )
  (else
    (define-constant C_WORD_SIZE (/ 32 8))
    (define-inline (pointer-uword-ref ptr) (pointer-u32-ref ptr)) ) )

(define-inline (object-uword-ref proc #!optional (idx 0))
  ;skip over C_WORD header
  (pointer-uword-ref (pointer+ (object->pointer proc) (* C_WORD_SIZE (add1 idx)))) )
